﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Query;
using System.Xml.XLinq;
using System.Data.DLinq;
using System.Reflection;

// For the definition of the [Extension] attribute.
using System.Runtime.CompilerServices;
[assembly:Extension]

namespace MyExtensionsLibrary
{
    [Extension]
    public static class MyExtensions
    {
        // This method allows any object to display the assembly 
        // it is defined in.
        [Extension]
        public static void DisplayDefiningAssembly(this object obj)
        {
            Console.WriteLine("{0} lives here:\n\t->{1}\n", obj.GetType().Name,
                Assembly.GetAssembly(obj.GetType()));
        }

        // This method allows any any integer to reverse its digits.
        // for example, 56 would return 65.
        [Extension]
        public static int ReverseDigits(this int i)
        {
            // Translate int into a string, and then
            // get all the characters. 
            char[] digits = i.ToString().ToCharArray();

            // Now reverse items in the array.
            Array.Reverse(digits);

            // Put back into string.
            string newDigits = new string(digits);

            // Finally, return the modified string back as an int.
            return int.Parse(newDigits);
        }
    }
}

